<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: png/writepng.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_faf003682c2bcfc217df395c6fafe5c7.html">png</a>
  </div>
</div>
<div class="contents">
<h1>writepng.c</h1><a href="writepng_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: writepng.c 2987 2010-03-01 17:45:38Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="writepng_8h.html">writepng.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">/* for getpwuid</span>
<a name="l00031"></a>00031 <span class="comment">EXTERN_C_BEGIN</span>
<a name="l00032"></a>00032 <span class="comment">#include &lt;pwd.h&gt;</span>
<a name="l00033"></a>00033 <span class="comment">#include &lt;sys/types.h&gt;</span>
<a name="l00034"></a>00034 <span class="comment">#include &lt;unistd.h&gt;</span>
<a name="l00035"></a>00035 <span class="comment">EXTERN_C_END</span>
<a name="l00036"></a>00036 <span class="comment">*/</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a><a class="code" href="writepng_8h.html#a7770d19aebe21e0a423fd40781030bcb">00039</a> <span class="keywordtype">int</span> <a class="code" href="writepng_8c.html#a7770d19aebe21e0a423fd40781030bcb">WritePNGfile</a>(<span class="keywordtype">char</span> *file_name, <span class="keywordtype">int</span> width, <span class="keywordtype">int</span> height, png_bytepp image, <span class="keywordtype">char</span> *desc)
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   FILE *fp;
<a name="l00042"></a>00042   png_structp  png_ptr;
<a name="l00043"></a>00043   png_infop    info_ptr;
<a name="l00044"></a>00044   png_text     text_ptr[3];
<a name="l00045"></a>00045   <span class="keywordtype">int</span>          bit_depth=8;
<a name="l00046"></a>00046   png_color_16 vtrans_values;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="comment">/*</span>
<a name="l00049"></a>00049 <span class="comment">  struct passwd       *t_passwd;</span>
<a name="l00050"></a>00050 <span class="comment">*/</span>
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="keywordtype">int</span> rank,size;
<a name="l00055"></a>00055   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00056"></a>00056   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="keywordflow">if</span> (rank) {
<a name="l00059"></a>00059     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00060"></a>00060   }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="comment">/* code template taken from example.c supplied with libpng */</span>
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">/* open the file */</span>
<a name="l00065"></a>00065   fp = fopen(file_name, <span class="stringliteral">&quot;wb&quot;</span>);
<a name="l00066"></a>00066   <span class="keywordflow">if</span> (fp == NULL)
<a name="l00067"></a>00067      <span class="keywordflow">return</span> (1);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="comment">/* Create and initialize the png_struct with the desired error handler</span>
<a name="l00070"></a>00070 <span class="comment">   * functions.  If you want to use the default stderr and longjump method,</span>
<a name="l00071"></a>00071 <span class="comment">   * you can supply NULL for the last three parameters.  We also check that</span>
<a name="l00072"></a>00072 <span class="comment">   * the library version is compatible with the one used at compile time,</span>
<a name="l00073"></a>00073 <span class="comment">   * in case we are using dynamically linked libraries.  REQUIRED.</span>
<a name="l00074"></a>00074 <span class="comment">   */</span>
<a name="l00075"></a>00075   png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING,
<a name="l00076"></a>00076      NULL, NULL, NULL);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="keywordflow">if</span> (png_ptr == NULL)
<a name="l00079"></a>00079   {
<a name="l00080"></a>00080      fclose(fp);
<a name="l00081"></a>00081      <span class="keywordflow">return</span> (1);
<a name="l00082"></a>00082   }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">/* Allocate/initialize the image information data.  REQUIRED */</span>
<a name="l00085"></a>00085   info_ptr = png_create_info_struct(png_ptr);
<a name="l00086"></a>00086   <span class="keywordflow">if</span> (info_ptr == NULL)
<a name="l00087"></a>00087   {
<a name="l00088"></a>00088      fclose(fp);
<a name="l00089"></a>00089      png_destroy_write_struct(&amp;png_ptr, NULL);
<a name="l00090"></a>00090      <span class="keywordflow">return</span> (1);
<a name="l00091"></a>00091   }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <span class="comment">/* Set error handling.  REQUIRED if you aren&#39;t supplying your own</span>
<a name="l00094"></a>00094 <span class="comment">   * error handling functions in the png_create_write_struct() call.</span>
<a name="l00095"></a>00095 <span class="comment">   */</span>
<a name="l00096"></a>00096   <span class="keywordflow">if</span> (setjmp(png_jmpbuf(png_ptr)))
<a name="l00097"></a>00097   {
<a name="l00098"></a>00098      <span class="comment">/* If we get here, we had a problem reading the file */</span>
<a name="l00099"></a>00099      fclose(fp);
<a name="l00100"></a>00100      png_destroy_write_struct(&amp;png_ptr, &amp;info_ptr);
<a name="l00101"></a>00101      <span class="keywordflow">return</span> (1);
<a name="l00102"></a>00102   }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">/* One of the following I/O initialization functions is REQUIRED */</span>
<a name="l00105"></a>00105   <span class="comment">/* set up the output control if you are using standard C streams */</span>
<a name="l00106"></a>00106   png_init_io(png_ptr, fp);
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">/* This is the hard way */</span>
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">/* Set the image information here.  Width and height are up to 2^31,</span>
<a name="l00111"></a>00111 <span class="comment">   * bit_depth is one of 1, 2, 4, 8, or 16, but valid values also depend on</span>
<a name="l00112"></a>00112 <span class="comment">   * the color_type selected. color_type is one of PNG_COLOR_TYPE_GRAY,</span>
<a name="l00113"></a>00113 <span class="comment">   * PNG_COLOR_TYPE_GRAY_ALPHA, PNG_COLOR_TYPE_PALETTE, PNG_COLOR_TYPE_RGB,</span>
<a name="l00114"></a>00114 <span class="comment">   * or PNG_COLOR_TYPE_RGB_ALPHA.  interlace is either PNG_INTERLACE_NONE or</span>
<a name="l00115"></a>00115 <span class="comment">   * PNG_INTERLACE_ADAM7, and the compression_type and filter_type MUST</span>
<a name="l00116"></a>00116 <span class="comment">   * currently be PNG_COMPRESSION_TYPE_BASE and PNG_FILTER_TYPE_BASE. REQUIRED</span>
<a name="l00117"></a>00117 <span class="comment">   */</span>
<a name="l00118"></a>00118   png_set_IHDR(png_ptr, info_ptr, width, height, bit_depth, PNG_COLOR_TYPE_RGB,
<a name="l00119"></a>00119      PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="comment">/*</span>
<a name="l00123"></a>00123 <span class="comment">  t_passwd=getpwuid(geteuid());</span>
<a name="l00124"></a>00124 <span class="comment">*/</span>
<a name="l00125"></a>00125   <span class="comment">/* Optionally write comments into the image */</span>
<a name="l00126"></a>00126   text_ptr[0].key = (png_charp)<span class="stringliteral">&quot;Title&quot;</span>;
<a name="l00127"></a>00127   text_ptr[0].text = file_name;
<a name="l00128"></a>00128   text_ptr[0].compression = PNG_TEXT_COMPRESSION_NONE;
<a name="l00129"></a>00129   text_ptr[1].key = (png_charp)<span class="stringliteral">&quot;Author&quot;</span>;
<a name="l00130"></a>00130   text_ptr[1].text = (png_charp)<span class="stringliteral">&quot;unknown&quot;</span>;
<a name="l00131"></a>00131 <span class="comment">/*</span>
<a name="l00132"></a>00132 <span class="comment">  text_ptr[1].text = t_passwd-&gt;pw_name;</span>
<a name="l00133"></a>00133 <span class="comment">*/</span>
<a name="l00134"></a>00134   text_ptr[1].compression = PNG_TEXT_COMPRESSION_NONE;
<a name="l00135"></a>00135   text_ptr[2].key = (<span class="keywordtype">char</span>*)<span class="stringliteral">&quot;Description&quot;</span>;
<a name="l00136"></a>00136   text_ptr[2].text = desc;
<a name="l00137"></a>00137   text_ptr[2].compression = PNG_TEXT_COMPRESSION_zTXt;
<a name="l00138"></a>00138   png_set_text(png_ptr, info_ptr, text_ptr, 3);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <span class="comment">/* other optional chunks like cHRM, bKGD, tRNS, tIME, oFFs, pHYs, */</span>
<a name="l00141"></a>00141   <span class="comment">/* note that if sRGB is present the gAMA and cHRM chunks must be ignored</span>
<a name="l00142"></a>00142 <span class="comment">   * on read and must be written in accordance with the sRGB profile */</span>
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   vtrans_values.red=  255;
<a name="l00145"></a>00145   vtrans_values.green=255;
<a name="l00146"></a>00146   vtrans_values.blue= 255;
<a name="l00147"></a>00147   png_set_tRNS(png_ptr, info_ptr, NULL, 1, &amp;vtrans_values);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="comment">/* Write the file header information.  REQUIRED */</span>
<a name="l00150"></a>00150   png_write_info(png_ptr, info_ptr);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">/* If you want, you can write the info in two steps, in case you need to</span>
<a name="l00153"></a>00153 <span class="comment">   * write your private chunk ahead of PLTE:</span>
<a name="l00154"></a>00154 <span class="comment">   *</span>
<a name="l00155"></a>00155 <span class="comment">   *   png_write_info_before_PLTE(write_ptr, write_info_ptr);</span>
<a name="l00156"></a>00156 <span class="comment">   *   write_my_chunk();</span>
<a name="l00157"></a>00157 <span class="comment">   *   png_write_info(png_ptr, info_ptr);</span>
<a name="l00158"></a>00158 <span class="comment">   *</span>
<a name="l00159"></a>00159 <span class="comment">   * However, given the level of known- and unknown-chunk support in 1.1.0</span>
<a name="l00160"></a>00160 <span class="comment">   * and up, this should no longer be necessary.</span>
<a name="l00161"></a>00161 <span class="comment">   */</span>
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <span class="comment">/* Once we write out the header, the compression type on the text</span>
<a name="l00164"></a>00164 <span class="comment">   * chunks gets changed to PNG_TEXT_COMPRESSION_NONE_WR or</span>
<a name="l00165"></a>00165 <span class="comment">   * PNG_TEXT_COMPRESSION_zTXt_WR, so it doesn&#39;t get written out again</span>
<a name="l00166"></a>00166 <span class="comment">   * at the end.</span>
<a name="l00167"></a>00167 <span class="comment">   */</span>
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="comment">/* set up the transformations you want.  Note that these are</span>
<a name="l00170"></a>00170 <span class="comment">   * all optional.  Only call them if you want them.</span>
<a name="l00171"></a>00171 <span class="comment">   */</span>
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="comment">/* The easiest way to write the image (you may have a different memory</span>
<a name="l00174"></a>00174 <span class="comment">   * layout, however, so choose what fits your needs best).  You need to</span>
<a name="l00175"></a>00175 <span class="comment">   * use the first method if you aren&#39;t handling interlacing yourself.</span>
<a name="l00176"></a>00176 <span class="comment">   */</span>
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <span class="comment">/* One of the following output methods is REQUIRED */</span>
<a name="l00179"></a>00179   png_write_image(png_ptr, image);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   <span class="comment">/* You can write optional chunks like tEXt, zTXt, and tIME at the end</span>
<a name="l00182"></a>00182 <span class="comment">   * as well.  Shouldn&#39;t be necessary in 1.1.0 and up as all the public</span>
<a name="l00183"></a>00183 <span class="comment">   * chunks are supported and you can use png_set_unknown_chunks() to</span>
<a name="l00184"></a>00184 <span class="comment">   * register unknown chunks into the info structure to be written out.</span>
<a name="l00185"></a>00185 <span class="comment">   */</span>
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <span class="comment">/* It is REQUIRED to call this to finish writing the rest of the file */</span>
<a name="l00188"></a>00188   png_write_end(png_ptr, info_ptr);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="comment">/* clean up after the write, and free any memory allocated */</span>
<a name="l00191"></a>00191   png_destroy_write_struct(&amp;png_ptr, &amp;info_ptr);
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="comment">/* close the file */</span>
<a name="l00194"></a>00194   fclose(fp);
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00198"></a>00198 }
<a name="l00199"></a>00199 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

